﻿var rd_tr_per_page=30;//运行数据表格每页显示行数
var clock_svr={syn_tm:0,svr_tm:0,lst_tm:0};	//时钟
var bgColor_ok,bgColor_warn='yellow',bgColor_err='red';//故障及正常情况下的背景色
var siteInfo;// 从站信息
var ctrlDat;// 控制参数
var runDat;
var lastHttpTime;// 最近一次监控时间
var errTimes;// 连续错误次数，成功一次则清零
var rthS1 = '<td class="tm">时间</td><td class="C1">流量<br />T/h</td><td class="C2">频率1<br />Hz</td><td class="C3">频率2<br />Hz</td><td class="C4">瓦特1A<br />Mpa</td><td class="C5">瓦特1V<br />Mpa</td><td class="C6">瓦特2A<br />Mpa</td><td class="C7">瓦特2V<br />Mpa</td><td class="C8">压力1<br />Mpa</td><td class="C9">压力2<br />Mpa</td><td class="C10">压力3<br />Mpa</td><td class="C11">温度1<br />℃</td><td class="C12">温度2<br />℃</td><td class="C13">温度3<br />℃</td><td class="C14">阀开度<br /></td><td class="ec"><a target="ec" href="ec.htm">故障代码</a></td></tr>';
var rtrS1 = '<tr><td class="tm">sj</td><td class="C1">wd2</td><td class="C2">wd1</td><td class="C3">wd2</td><td class="C4">yl</td><td class="C5">压力</td><td class="C6">流量</td><td class="C7">频率</td><td class="C8">电流</td><td class="C9">yl</td><td class="C10">压力</td><td class="C11">流量</td><td class="C12">频率</td><td class="C13">电流</td><td class="C14">电流</td><td class="ec" ec="$ec$">故障</td></tr>';
var jzh=0;
var bg_c_tr;//表格行-原背景色
var scroll_ = (document.documentElement?document.documentElement:document.body);
var wskt;

/**
 * 初始化创建表格 - 实时运行数据
 */
function init_th(){
	var ths='流量,T/h,频率1,Hz,频率2,Hz,瓦特1A,Mpa,瓦特1V,Mpa,瓦特2A,Mpa,瓦特2V,Mpa,压力1,Mpa,压力2,Mpa,压力3,Mpa,温度1,℃,温度2,℃,温度3,℃,阀开度,%'.split(',');//表头名称
	var tbh=$('#r_hdr thead'),tbb=$('#r_hdr tbody'),trh,trd;
	//添加表头行
		tbh.append(trh=$('<tr><th class="tm"/>').text('时间'));
		tbb.append(trd=$('<tr><td class="tm"/>').text('时间'));
		for(var c=0; c<ths.length; ){
			var cl='C'+(c+1);
			trh.append($('<th>'+ths[c++]+'<br/>'+ths[c++]+'</td>').addClass(cl))
			trd.append($('<td>&nbsp;</td>').addClass(cl))
		}
}


function wskt_onmessage(msg){
	console.log(msg.data);
	var cod=msg.data.substr(0,2);
	var dat=msg.data.substr(4);
	if("QI"==cod){
		var json=JSON.parse(dat);
		http_get_SiteInfo_cb(json);
		$("#s_area").change();
		return;
	}
	if("02"==cod){
			clock_svr.svr_tm=Number(dat);					clock_svr.syn_tm=clock_svr.svr_tm;
			clock_svr.lst_tm=new Date().getTime();
			$("#clock").html(formatTime_1(new Date(clock_svr.svr_tm))).css('background-color',bgColor_ok);
			return;
	}
	if("03"==cod){
		var json=JSON.parse(dat);
		http_get_RunDat_cb(json);
		return;
	}
	if("04"==cod){
		var json=JSON.parse(dat);
			if (json == null) {
				warnErr("MxS", true);
			} else if (json.flag==0) {
				errTimes = 0;
				http_get_RunDat_his_callback(json);
			} else {
				warnErr("MxS", true);
			}
		return;
	}
	if("05"==cod){
		var json=JSON.parse(dat);
		http_get_CtrlDat_cb(json);
		return;
	}
	if("07"==cod){
		if(dat.substr(0,1)=='E'){
			alert('密码错误');
			return;
		}
		if(dat.substr(1,2)=='PL'){//调整频率
		}
		http_get_CtrlDat_cb(json);
		return;
	}
}

function open_wskt(){
	wskt = new ReconnectingWebSocket('ws://127.0.0.1:11101/wskt');
	wskt.onopen = function (msg) {
  	console.log("<br>[opened] ");
  	wskt.send("QI#"); 
  	wskt.onmessage=wskt_onmessage;
  };
  wskt.onclose = function (msg) {
  	console.log("websocket closed, try reconnect ...");
  };
  wskt.error = function (msg) {
  	console.log("websocket error:");
 	};
 	
}

function view_init() {
	bgColor_ok=$("div#r_hdr tbody td").eq(0).css("background-color");
	
	open_wskt();
 	 
	
	// 初始化 事件-设置栏
	$("div#s_val input[class^=spnr]").each(function(i) {
		$(this).dblclick(function() {
			if (!validate_ctrl_enbl()) {
				return;
			}
			$(this).spinner({
				step : $(this).attr("v_step"),
				max:$(this).attr("v_max"),
				min:$(this).attr("v_min"),
				numberFormat : "n"
			});
			$(this).blur(function() {
				$(this).spinner("destroy");
				http_post_CtrlDat($(this),$("div#s_val input#set_enbl").val());
			});
		});
	});

	//开关按键控制
	$("#yxkz img").dblclick( function () {
		if(!ctrlDat) return;
		var bpqKG_mask=0x01<<jzh;
		var bpqKG=ctrlDat.bpqKG&bpqKG_mask;
		if(bpqKG==0){
			//当前关闭状态
			if(confirm("确实要开启么？")){
				var ipt=prompt('请输入密码:');
				if(!validatep(ipt)){
					alert('密码错误！');
					return;
				}else{
					//$(this).closest("tr").find(".sm").html('正在开启，请等待');
					ctrlDat.bpqKG|=bpqKG_mask;
					yxkz_show(10,'正在开启，请等待...');
					http_post_CtrlDat($(this),ipt);
				}
			}
		}else{
			//当前开启状态
			if(confirm("确实要关闭么？")){
				var ipt=prompt('请输入密码:');
				if(!validatep(ipt)){
					alert('密码错误！');
					return;
				}else{
					//$(this).closest("tr").find(".sm").html('正在关闭，请等待');
					ctrlDat.bpqKG&=(~bpqKG_mask);
					yxkz_show(11,'正在关闭，请等待...');
					http_post_CtrlDat($(this),ipt);
				}
			}
		}
	});
		
	$("#itv").change(function() {
		show_his_dat();
		$('body').stopTime('URD');
		$('body').everyTime($(this).val(), 'URD', function() {
				var o_jq = $("div#r_bdy");
					o_jq.find("table").prepend($("div#r_hdr tbody tr").clone(true));
					var trs = o_jq.find("table tr");
					if (trs.size() > rd_tr_per_page)
						trs.last().remove();
		});
	});
	
	// 初始化 事件-分区选择
	$("#s_area").change(function() {
		jzh=$("#s_area")[0].selectedIndex;
			view_ax_load_rd();
			view_ax_load_cd();
			document.title = siteInfo.name + " :监控- " + $(this).val();
			// 更新控制参数
			http_get_CtrlDat();
	});
	$("#s_area").attr("disabled",true);
	
	$("body").tooltip({
		track: true,
		tooltipClass: "custom-tooltip"
	});
	
	//数据回顾
	$("input#d1_view").click(function() {
		WdatePicker({
			onpicked : show_his_dat,
			dateFmt : 'yyyy年M月d日 H:m',
			realDateFmt:'yyyyMMdd',
			realTimeFmt:'HHmmss',
			realFullFmt:'%Date%Time',
			vel:'d1_val',
			minDate : '2013-10-01 00:00:00',
			maxDate : '%yyyy-%M-%d %H:%m:%s',
			readOnly : true
		});
	});
	$("div#h_hg1").css("display", "none");
	$("#btn_hg").click(function() {
		$("div#h_hg").css("display", "none");
		$("div#h_hg1").css("display", "block");
	});
	$("#btn_back").click(function() {
		$("div#h_hg1").css("display", "none");
		$("div#h_hg").css("display", "block");
		$("input#d1_val").val('');
		$("input#d1_view").val('');
		//rd_auto=true;
		$("div#m_b td.rd").html("&nbsp;");
		$("div#m_b td.gz").html("&nbsp;").css('background-color',bgColor_ok);
		http_get_RunDat_his(runDat.time,0-rd_tr_per_page);
	});
	
	//刷新运行数据-获取从站信息
	$('body').everyTime('1s', 'Timer_RD', function() {
		var date = new Date();
		var sec=date.getSeconds();
		update_clock(date);
			
		if(sec%5==0){
			lastHttpTime = curTimeMs();
			wskt.send("03#");
		}
		if(sec%15==3){
			lastHttpTime = curTimeMs();
			wskt.send("05#");
		}
		
		if(clock_svr.lst_tm>0 && date.getTime()-clock_svr.lst_tm>$("#itv").val()){
					var o_jq = $("div#r_bdy");
					o_jq.find("table").prepend($("div#r_hdr tbody tr").clone(true));
					var trs = o_jq.find("table tr");
					if (trs.size() > rd_tr_per_page)
						trs.last().remove();
					clock_svr.lst_tm=date.getTime();
		}
	});
}

function init_set_page_height() {
	var fs=Number($("body").css("font-size").replace('px',''));
	if(hasScroll()){
		for(var i=1; i<=3; i++){
			$("body").css("font-size", fs-i+'px');
			if(!hasScroll()){
				break;
			}
		}
	}else{
		for(var i=1; i<=3; i++){
			$("body").css("font-size", fs+i+'px');
			if(hasScroll()){
				$("body").css("font-size", fs+i-1+'px');
				break;
			}
		}
	}
	fs=Number($("body").css("font-size").replace('px',''));
	
	var ih=$("#bm_set")[0].offsetHeight;
	for(var i=1,stp=10,ch=ih; i<20; i++){
		ch += stp;
		$("#bm_set").css("height", ch+'px');
		if(hasScroll()){
			$("#bm_set").css("height", ch-stp+'px');
			break;
		}
	}
	
	var h_bm_left = $("#bm_set")[0].offsetHeight;
	var h_bh=$("#body_head")[0].offsetHeight;
	var h_rh=$("#r_hdr")[0].offsetHeight;
	//表格高
	var h_rb=h_bm_left - h_bh - h_rh -5;
	$("#r_bdy").css("height", h_rb+'px');
	for(var i=1; hasScroll() && i<3; i++){
		h_rb -= 5;
		$("#r_bdy").css("height", h_rb+'px');
	}
}

function update_clock(date){
	if(clock_svr.syn_tm==0 || date.getTime()-clock_svr.lst_tm>10000){
		wskt.send("02#");
	}else{
		clock_svr.svr_tm+=1000;
		$("#clock").html(formatTime_1(new Date(clock_svr.svr_tm))).css('background-color',bgColor_ok);
	}
}
// ========================http ajax
// 回调=============================================
// 控制参数获取成功后回调，填充控制参数
function http_get_CtrlDat_callback(json) {
	var o_c_set = $("div#s_val"), ips;
	
	if (0 == jzh) {
		ips = o_c_set.find("#c_pl input.spnrSb");// 频率
		ips.val(d_fmt.Pl_dec(json.SbPlS1)).prop("disabled", false);
		
		ips = o_c_set.find("#c_hw1 input.spnrWd");// 温度
		ips = o_c_set.find("#c_hw2 input.spnrWd");
		ips = o_c_set.find("#c_gw input.spnrWd");
		ips.eq(0).val(d_fmt.Wd_dec(json.GsWdS1));
		ips.eq(1).val(d_fmt.Wd_dec(json.GsWdS1c));
		ips.prop("disabled", false);
		
		ips = o_c_set.find("#c_gy input.spnrYl");// 压力
		ips.eq(1).val(d_fmt.Yl_dec(json.GsYlS1 - json.GsYlS1_Lv));
		ips.eq(0).val(d_fmt.Yl_dec(json.GsYlS1));
		ips.prop("disabled", false);
		ips = o_c_set.find("#c_hy input.spnrYl");
		ips.eq(0).val(d_fmt.Yl_dec(json.HsYlS1));
		ips.eq(1).val(d_fmt.Yl_dec(json.HsYlS1_Uv - json.HsYlS1));
		ips.prop("disabled", false);
	} else {
		var jzidx=jzh-1;
		ips = o_c_set.find("#c_pl input.spnrSb");// 频率
		ips.val(d_fmt.Pl_dec(json.SbPlS2[jzidx])).prop("disabled", false);
		
		ips = o_c_set.find("#c_hw1 input.spnrWd");// 温度
		ips.eq(0).val(d_fmt.Wd_dec(json.HsWd1[jzidx]));
		ips.eq(1).val(d_fmt.Wd_dec(json.HsWd1c[jzidx]));
		ips.prop("disabled", false);
		ips = o_c_set.find("#c_hw2 input.spnrWd");
		ips.eq(0).val(d_fmt.Wd_dec(json.HsWdS2[jzidx]));
		ips.eq(1).val(d_fmt.Wd_dec(json.HsWdS2_Uv[jzidx] - json.HsWdS2[jzidx]));
		ips.prop("disabled", false);
		ips = o_c_set.find("#c_gw input.spnrWd");
		ips.eq(0).val(d_fmt.Wd_dec(json.GsWdS2[jzidx]));
		ips.eq(1).val(d_fmt.Wd_dec(json.GsWdS2_Uv[jzidx] - json.GsWdS2[jzidx]));
		ips.prop("disabled", false);
		
		ips = o_c_set.find("#c_gy input.spnrYl");// 压力
		ips.eq(0).val(d_fmt.Yl_dec(json.GsYlS2[jzidx]));
		ips.eq(1).val(d_fmt.Yl_dec(json.GsYlS2_Uv[jzidx] - json.GsYlS2[jzidx]));
		ips.prop("disabled", false);
		ips = o_c_set.find("#c_hy input.spnrYl");
		ips.eq(0).val(d_fmt.Yl_dec(json.HsYlS2[jzidx]));
		ips.eq(1).val(d_fmt.Yl_dec(json.HsYlS2_Uv[jzidx] - json.HsYlS2[jzidx]));
		ips.prop("disabled", false);
	}
	o_c_set.find("input#set_enbl").prop("disabled", false).prop("readonly", false);
	o_c_set.find("select#itv").prop("disabled", false);
}

// 更新监控实时数据
function http_get_RunDat_callback(json) {
	//刷新实时运行数据
	setRundat($("div#r_hdr tbody tr"), json);
	
	onErrCode(json);
}

//填充运行数据
function setRundat(tr_jq,json_run){
	var ecv,ec1=json_run.ErrCodeS1;
	tr_jq.find("td").html("--");
	
	tr_jq.attr("time",json_run.time);
	tr_jq.find("td.tm").html(getTimeL(json_run.time));
	if(jzh==0){
		if(ec1!=0){
			tr_jq.find("td.ec").html(encodeGz(ec1)).attr("ec",ec1).css("background-color",bgColor_err);
			if(e_mask.dec_MxSxD(ec1)!=0){
				return;
			}
		}else{
			tr_jq.find("td.ec").html("&nbsp;").attr("ec",ec1).css("background-color",bgColor_ok);
		}
		if((ecv=e_mask.dec_GsWd(ec1))!=3)
			tr_jq.find("td.gw").html(d_fmt.Wd_dec(json_run.GsWdS1));
		if((ecv=e_mask.dec_GsYl(ec1))!=3)
			tr_jq.find("td.gy").html(d_fmt.Yl_dec(json_run.GsYlS1));
		if((ecv=e_mask.dec_HsYl(ec1))!=3)
			tr_jq.find("td.hy").html(d_fmt.Yl_dec(json_run.HsYlS1));
		if((ecv=e_mask.dec_Ll(ec1))!=3)
			tr_jq.find("td.ll").html(d_fmt.Ll_dec(json_run.LlS1));
		tr_jq.find("td.pl").html(d_fmt.Pl_dec(json_run.CtrlPlS1));
		if((ecv=e_mask.dec_SbDl(ec1))!=3)
			tr_jq.find("td.dl").html(d_fmt.Dl_dec(jzh,json_run.SbDlS1));
	}else{
		var ec2=json_run.ErrCodeS2[jzh-1];
		if(ec2==0){
			tr_jq.find("td.ec").html("&nbsp;").attr("ec",ec2).css("background-color",bgColor_ok);
		}else{
			tr_jq.find("td.ec").html(encodeGz(ec2)).attr("ec",ec2).css("background-color",bgColor_err);
		}
		if((ecv=e_mask.dec_MxSxD(ec1))!=0){
			return;
		}
		if((ecv=e_mask.dec_GsWd(ec2))!=3)
			tr_jq.find("td.gw").html(d_fmt.Wd_dec(json_run.GsWdS2[(jzh-1)]));
		if((ecv=e_mask.dec_HsWdS1(ec2))!=3)
			tr_jq.find("td.hw1").html(d_fmt.Wd_dec(json_run.HsWdS1[(jzh-1)]));
		if((ecv=e_mask.dec_HsWdS2(ec2))!=3)
			tr_jq.find("td.hw2").html(d_fmt.Wd_dec(json_run.HsWdS2[(jzh-1)]));
		if((ecv=e_mask.dec_GsYl(ec2))!=3)
			tr_jq.find("td.gy").html(d_fmt.Yl_dec(json_run.GsYlS2[(jzh-1)]));
		if((ecv=e_mask.dec_HsYl(ec2))!=3)
			tr_jq.find("td.hy").html(d_fmt.Yl_dec(json_run.HsYlS2[(jzh-1)]));
		if((ecv=e_mask.dec_Ll(ec2))!=3)
			tr_jq.find("td.ll").html(d_fmt.Ll_dec(json_run.LlS2[(jzh-1)]));
		tr_jq.find("td.pl").html(d_fmt.Pl_dec(json_run.CtrlPlS2[(jzh-1)]));
		if((ecv=e_mask.dec_SbDl(ec2))!=3)
			tr_jq.find("td.dl").html(d_fmt.Dl_dec(jzh,json_run.SbDlS2[(jzh-1)]));
	}
}
/**
 * 根据故障码变更告警图标
 */
function onErrCode(json_run){
	var ecv,ec1=json_run.ErrCodeS1,ec2=0;
	$("div.r_err img").each(function(i){this.src=img_0.src;});//指示灯---归0
	//停电指示灯
	if((ecv=e_mask.dec_MxSxD(ec1))!=0){
		$("img#e_MxS")[0].src=img_e.src;
		return;
	}else{
		$("img#e_MxS")[0].src=img_n.src;
	}
	
	//运行指示灯： 开-绿灯；关-白灯；关闭状态有电流时-绿白闪烁
	if(((json_run.bpqKG>>jzh)&0x01)==0){
		$("#yxkz img")[0].src=img_0.src;
	}else{
		if((jzh==0?json_run.SbDlS1:json_run.SbDlS2[jzh-1])>0){
			$("#yxkz img")[0].src=img_n.src;
		}else{
			$("#yxkz img")[0].src=img_ss.src;
		}
	}
		
	if(jzh==0){
		//if(ec1==0) return;
		ec2=json_run.ErrCodeS2[0];
		
		//供水温度指示灯
		if((ecv=e_mask.dec_GsWd(ec1))!=0){
				$("img#e_GsWd")[0].src=img_e.src;
		}else{
				$("img#e_GsWd")[0].src=img_n.src;
		}
		//回水温度指示灯
		if((ecv=e_mask.dec_HsWdS1(ec2))!=0){
				$("img#e_HsWd")[0].src=img_e.src;
		}else{
				$("img#e_HsWd")[0].src=img_n.src;
		}
		//电磁流量计
		if((ecv=e_mask.dec_Ll(ec1))!=0){
				$("img#e_Ll")[0].src=img_e.src;
		}else{
				$("img#e_Ll")[0].src=img_n.src;
		}
		//分&nbsp;布&nbsp;泵
		if((ecv=e_mask.dec_SbDl(ec1))!=0){
				$("img#e_fbb")[0].src=img_e.src;
		}else{
				$("img#e_fbb")[0].src=img_n.src;
		}
		//系统压力
		if((ecv=e_mask.dec_GsYl(ec1))!=0){
				$("img#e_GsYl")[0].src=ecv==3?img_0.src:img_e.src;
		}else{
				$("img#e_GsYl")[0].src=img_n.src;
		}
		//补水压力
		if((ecv=e_mask.dec_HsYl(ec1))!=0){
				$("img#e_HsYl")[0].src=ecv==3?img_0.src:img_e.src;
		}else{
				$("img#e_HsYl")[0].src=img_n.src;
		}
	}else{
		ec2=json_run.ErrCodeS2[jzh-1];
		//if(ec2==0) return;
		
		//供水温度指示灯
		if((ecv=e_mask.dec_GsWd(ec2))!=0){
				if(ecv!=3)$("img#e_GsWd")[0].src=img_e.src;
		}else{
				$("img#e_GsWd")[0].src=img_n.src;
		}
		//回水温度指示灯
		if((ecv=e_mask.dec_HsWdS2(ec2))!=0){
				if(ecv!=3)$("img#e_HsWd")[0].src=img_e.src;
		}else{
				$("img#e_HsWd")[0].src=img_n.src;
		}
		//电磁流量计
		if((ecv=e_mask.dec_Ll(ec2))!=0){
				$("img#e_Ll")[0].src=img_e.src;
		}else{
				$("img#e_Ll")[0].src=img_n.src;
		}
		//循&nbsp;环&nbsp;泵
		if((ecv=e_mask.dec_SbDl(ec2))!=0){
				$("img#e_xhb")[0].src=img_e.src;
		}else{
				$("img#e_xhb")[0].src=img_n.src;
		}
		//系统压力
		if((ecv=e_mask.dec_GsYl(ec2))!=0){
				if(ecv!=3)$("img#e_GsYl")[0].src=img_e.src;
		}else{
				$("img#e_GsYl")[0].src=img_n.src;
		}
		//补水压力
		if((ecv=e_mask.dec_HsYl(ec2))!=0){
				if(ecv!=3)$("img#e_HsYl")[0].src=img_e.src;
		}else{
				$("img#e_HsYl")[0].src=img_n.src;
		}
	}
}

// ========================界面 显示控制=============================================
// 初始化一次

function show_his_dat(){
	var od=$dp.cal.date;
	var nd=$dp.cal.newdate;
	var t1=$("#d1_val").val();
	var tdt=new Date();
	if(t1!=""){
		tdt=new Date(t1.substr(0,4),t1.substr(4,2)-1,t1.substr(6,2),t1.substr(8,2),t1.substr(10,2),0);
	}else if(runDat.time){
		tdt.setTime(runDat.time);
	}
	http_get_RunDat_his(tdt.getTime(),0-rd_tr_per_page*2);
}

// 每次分区切换时加载页面
function view_ax_load_rd() {
	var tb = $("div#r_hdr table");
	tb.find("tr").each(function(i) {
		$(this).remove();
	});
	tb.find("thead").append(rthS1);
	tb.find("tbody").append(rtrS1);
	tb.find("tbody td:last").tooltip({
			track: true,
			items: "img, [data-geo], [title], td",
			content: function() {
				var ec=$(this).attr("ec");
				var gzm=$(this).text();
				var xqm=siteInfo.name;
				var fqm=jzh==0?'':siteInfo.areaNames[jzh-1];
				return e_mask.err_desc(jzh,ec,gzm,xqm,fqm);
			}
	});
	
	$("div#r_bdy table").empty();
	if(runDat)
		http_get_RunDat_his(runDat.time,-2);
}


// 每次分区切换时加载页面
function view_ax_load_cd() {
	// 初始化 显示-设置栏
	$("div#s_val input").each(function(i) {
		$(this).val("--").prop("disabled", true).prop("readonly", true);
	});

	// 初始化 显示-选择框
	$("div#s_val select").each(function(i) {
		$(this).prop("disabled", true);
	});

	// 初始化 显示-指示灯
	$("div#p_set img").each(function(i) {
		this.src = img_0.src;
	});
	$("#MxS").attr("src", img_w.src);

	if (0 == jzh) {
		$("#c_pl label").html("分布泵设定频率");
	} else {
		$("#c_pl label").html("循环泵设定频率");
	}
	
}

	
function yxkz_show(new_val,msg){
	switch(new_val){
		case 0 :
			$("#yxkz img").attr("src",img_kg_off.src).closest("tr").find(".sm").html(msg?msg:'变频器已经关闭');
			break;
		case 1 :
			$("#yxkz img").attr("src",img_kg_on.src).closest("tr").find(".sm").html(msg?msg: '变频器正在运行');
			break;
		default:
			$("#yxkz img").attr("src",img_ss.src);
			if(msg)
				$("#yxkz img").closest("tr").find(".sm").html(msg);
				
	}
}

// ========================故障 指示灯=============================================
/**
 * 故障告警
 */
function warnErr(MxS, yes) {
	var im = $("img#" + MxS);
	if (yes)
		im.attr("src", img_e.src);
	else {
		im.attr("src", img_n.src);
	}
}



// ========================http ajax
// 通信=============================================

/**
 * http 通信 控制参数变更后，保存并上报
 */
function http_post_CtrlDat(o_ipt,p) {
	var wc=0;
	var o_c_set = $("div#s_val"),ips;

	if (0 == jzh) {
		ips = o_c_set.find("#c_pl input.spnrSb");// 频率
		ctrlDat.SbPlS1 = Number(d_fmt.Pl_enc(ips.val()));
				
		ips = o_c_set.find("#c_gw input.spnrWd");// 温度
		ctrlDat.GsWdS1c = Number(d_fmt.Wd_enc(ips.eq(1).val()));
		ctrlDat.GsWdS1 = Number(d_fmt.Wd_enc(ips.eq(0).val()));
		
		ips = o_c_set.find("#c_gy input.spnrYl");// 压力
								wc = Number(d_fmt.Yl_enc(ips.eq(1).val()));
		ctrlDat.GsYlS1 = Number(d_fmt.Yl_enc(ips.eq(0).val()));
		ctrlDat.GsYlS1_Lv = ctrlDat.GsYlS1 - wc;
		ctrlDat.GsYlS1_Uv = ctrlDat.GsYlS1 + wc;
		
		ips = o_c_set.find("#c_hy input.spnrYl");
								wc = Number(d_fmt.Yl_enc(ips.eq(1).val()));
		ctrlDat.HsYlS1 = Number(d_fmt.Yl_enc(ips.eq(0).val()));
		ctrlDat.HsYlS1_Lv = ctrlDat.HsYlS1 - wc;
		ctrlDat.HsYlS1_Uv = ctrlDat.HsYlS1 + wc;
	} else {
		var jzidx=jzh-1;
		ips = o_c_set.find("#c_pl input.spnrSb");// 频率
		ctrlDat.SbPlS2[jzidx] = Number(d_fmt.Pl_enc(ips.val()));
		
		ips = o_c_set.find("#c_hw1 input.spnrWd");// 温度
		ctrlDat.HsWd1c[jzidx]= Number(d_fmt.Wd_enc(ips.eq(1).val()));
		ctrlDat.HsWd1[jzidx] = Number(d_fmt.Wd_enc(ips.eq(0).val()));
		
		ips = o_c_set.find("#c_hw2 input.spnrWd");
											 wc = Number(d_fmt.Wd_enc(ips.eq(1).val()));
		ctrlDat.HsWdS2[jzidx] = Number(d_fmt.Wd_enc(ips.eq(0).val()));
		ctrlDat.HsWdS2_Lv[jzidx] = ctrlDat.HsWdS2[jzidx] - wc;
		ctrlDat.HsWdS2_Uv[jzidx] = ctrlDat.HsWdS2[jzidx] + wc;
		
		ips = o_c_set.find("#c_gw input.spnrWd");
											 wc = Number(d_fmt.Wd_enc(ips.eq(1).val()));
		ctrlDat.GsWdS2[jzidx] = Number(d_fmt.Wd_enc(ips.eq(0).val()));
		ctrlDat.GsWdS2_Lv[jzidx] = ctrlDat.GsWdS2[jzidx] - wc;
		ctrlDat.GsWdS2_Uv[jzidx] = ctrlDat.GsWdS2[jzidx] + wc;
		
		ips = o_c_set.find("#c_gy input.spnrYl");// 压力
											 wc = Number(d_fmt.Yl_enc(ips.eq(1).val()));
		ctrlDat.GsYlS2[jzidx] = Number(d_fmt.Yl_enc(ips.eq(0).val()));
		ctrlDat.GsYlS2_Lv[jzidx] = ctrlDat.GsYlS2[jzidx] - wc;
		ctrlDat.GsYlS2_Uv[jzidx] = ctrlDat.GsYlS2[jzidx] + wc;
		
		ips = o_c_set.find("#c_hy input.spnrYl");
											 wc = Number(d_fmt.Yl_enc(ips.eq(1).val()));
		ctrlDat.HsYlS2[jzidx] = Number(d_fmt.Yl_enc(ips.eq(0).val()));
		ctrlDat.HsYlS2_Lv[jzidx] = ctrlDat.HsYlS2[jzidx] - wc;
		ctrlDat.HsYlS2_Uv[jzidx] = ctrlDat.HsYlS2[jzidx] + wc;
	}
	$.post("s/c/", {
			'cv' : JSON.stringify(ctrlDat)
			,'1':hex_md5(p?p:$("div#s_val input#set_enbl").val())
		},
		function(data) {
			//alert(data); // John
		}, "json"
	);
}

/**
 * http 通信异常处理
 */
function http_on_ajaxError() {
	var re = new RegExp("s/([a-zA-Z0-9]+)/r");
	$(document).ajaxError(function(event, request, settings, err) {
		// alert('AjaxErr:' + request);
		errTimes++;
		warnErr("MxS", true);
	});
}

function http_get_SiteInfo_cb(json) {
		if (json == null) {
			warnErr("MxS", true);
		} else if (json.name) {
			errTimes = 0;
			siteInfo = json;
			if (siteInfo != null){
				$("#s_name").html(siteInfo.code + ":" + siteInfo.name);
			
				var o_area = $("#s_area");
				o_area.html("");
				o_area.append("<option selected>一次网</option>");
				for ( var i = 0; i < siteInfo.areaCount; i++) {
					o_area.append("<option>" + siteInfo.areaNames[i] + "</option>");
				}
				o_area.prop("disabled", false);
			}
		} else {
			warnErr("MxS", true);
		}
}

function http_get_RunDat_cb(json) {
		if (json == null) {
			warnErr("MxS", true);
		} else if (json.code) {
			errTimes = 0;
			runDat=json;
			http_get_RunDat_callback(json);
		} else {
			warnErr("MxS", true);
		}
}

// 查询设定参数
function http_get_CtrlDat() {
	lastHttpTime = curTimeMs();
	wskt.send("05#");
}
function http_get_CtrlDat_cb(json) {
		if (json == null) {
			warnErr("MxS", true);
		} else if (json.siteCode) {
			errTimes = 0;
			ctrlDat = json;

			http_get_CtrlDat_callback(json);
		} else {
			warnErr("MxS", true);
		}
}
	
//查询历史运行数据
function http_get_RunDat_his(time,row_size) {
	lastHttpTime = curTimeMs();
	wskt.send("04#"+time+","+row_size+","+$("#itv").val());
}

function http_get_RunDat_his_callback(json) {
		if(json.flag!=0)
			return;
		
		var trm=$("div#r_hdr tbody tr");
		var trn;
		var tb=$("div#r_bdy table");
		var rd;
		json.rows=Number(json.rows);
		
		tb.find("tr").remove();
		for(var n=json.rds.length-1;n>=0;n--){
			rd=json.rds[n];
			trn=trm.clone(true);
			
			setRundat(trn, rd);
			
			if(json.rows>0)
				tb.append(trn);
			else
				tb.prepend(trn);
		}
}
// ========================功能函数 =============================================
function validate_ctrl_enbl() {
	return validatep($("div#s_val input#set_enbl").val());
}
function validatep(p) {
	var mp=hex_md5(p);
	var flag;
			$.ajax({ url: "s/vp/", cache:false, dataType:"json", async:false
				,data:{'1':mp}
				,success: function(data, textStatus, jqXHR){
							flag=data;
				}
				,error:function(XmlHttpRequest,textStatus, errorThrown) {
				  return false;
			  }
			});
	return flag.v;
}
