﻿var wskt;
var wskt_uri='ws://'+window.location.hostname+':14109/wskt';

function wsktReq_hg(maddr,stime,rownum,step){
	wskt_send('F4#'+maddr+','+stime+','+rownum+','+step);
}
function wskt_send(msg){
	if(offline)return;
	//console.log(new Date().getSeconds()+":-->:"+msg);
	wskt.send(msg);
}
function wskt_onmessage(msg){
	offline=false;
	//console.log(new Date().getSeconds()+':<--:\t'+msg.data);
	var cod=msg.data.substr(0,2);
	var flg=msg.data.substr(3,1);
	var dat=msg.data.substr(4);
	if('02'==cod){
		svrtm.offset=parseInt(dat, 10)-new Date().getTime();
		svrtm.syn=new Date().getTime();
		return;
	}
	if('cd'==cod){
		$("#mm input").attr('r',flg=='O'?dat:'0');
		set_view();
		return;
	}
	if("QI"==cod){
		if(flg!='O'){
			console.log('WsktErr: '+msg.data);
			return;
		}
		sattr=JSON.parse(dat);
		$("select").attr("disabled",false);
		reqRd();
		return;
	}
	if("F4"==cod){
		if(flg!='O'){return;}
		var idx=dat.indexOf('=');
		var args=dat.substring(0,idx).split(',');
		if(curMcuAddr!=args[0]){
			console.log('F4_Err: curMcuAddr='+curMcuAddr+', rd.a='+rd.a);
			alert('检测到错误，请关闭浏览器，重新打开！');
			window.close();
		}

		var stime=new Number(args[1]),row=new Number(args[2]),step=new Number(args[3]);
		step=row>0?step:-step;
		var dat=dat.substring(idx+1);
		dat=JSON.parse(dat);
		hgTr(dat,stime,step);
		return;
	}
	if("04"==cod){
		if(flg!='O'){
			console.log('ERR[04]:\t'+msg.data);
			return;
		}
		rd=JSON.parse(dat);
		if(rd.a!=curMcuAddr){
			console.log('04_Err: curMcuAddr='+curMcuAddr+', rd.a='+rd.a);
			alert('检测到错误，请关闭浏览器，重新打开！');
			window.close();
		}

		var obj;
		if(obj=$('#kg img')){//更新运行指示灯
			if(rd.c-rd.t>30000){//设备断线
				if(s!='j')change_kg('j');
			}else{
				var s=obj.attr('s');
				if(rd.kh&&rd.ks){//运行
					if(s!='y') change_kg('y');
				}else{
					if(!rd.kh){//关
						if(s!='g'){change_kg('g');}
					}else{//停
						if(s!='t'){change_kg('t');}
					}
				}
				obj.removeAttr('doing');
			}
		}

		//更新变频器告警指示灯
		$('#st_20 img').css('display',rd.j1?'block':'none');
		$('#st_21 img').css('display',rd.j2?'block':'none');

		scrollDownRd();//尝试下滑数据
		$('#r_hdr tbody td').each(function(i){//更新运行数据
			if(i==0)
				$(this).attr('t',rd.t).html((new Date(rd.t).fmt("hh:mm:ss")));
			else{
				var k=$(this).attr('class').replace(/.*C(\d+).*/,'$1');
				if(rd.z[k]==-1){
					$(this).html('--').addClass('w');
				}else if(rd.z[k]==-2){
					$(this).html(' ');
				}else
					$(this).html(int2float(rd.z[k],rdxs[k]));
			}
		});

		$("span[id^=st_] input").each(function(i) {//更新设定值
			if($(this).attr('ov'))return;
			var idx=$(this).attr('fid').substring(4);
			this.value=int2float(rd.s[idx],stxs[idx]);
		});
		return;
	}
	if("ML"==cod){
		$('#res').val(dat);
		return;
	}
	if("kg"==cod){
		if('O'==flg){//更新运行指示灯
//			rd.ks=!rd.ks;//由固定读状态决定
//			if(!rd.ks){
//				change_kg('t');
//			}else{
//				change_kg('y');
//			}
		}else if(flg=='V'){
			alert('密码错误');
		}else{
			alert('执行失败');
		}
		return;
	}
	if("st"==cod){//设定值 st#E20,1,500:232323
		var a=dat.split(",");
		if('O'!=flg){//修改失败，恢复原始值
			console.log('设定失败:'+'st_'+a[0]);
			if(curMcuAddr==a[1]){
				var v=int2float(st[a[0]],stxs[a[0]]);
				var o=$('#st_'+a[0]+' input');
				if(o)o[0].value=v;
			}
		}
		return;
	}
}

function open_wskt(){
	wskt = new ReconnectingWebSocket(wskt_uri);
	wskt.onopen = function (msg) {
		$('#s_area').change();
		offline=false;
	  	wskt.send('QI#');
	  	wskt.send('02#');
	  	if(!inited)
	  		view_init();
	};
	wskt.onmessage=wskt_onmessage;
	wskt.onclose=function() {
		offline=true;
		$('#clock').html("无法连接服务器").addClass('w');
		$("#mm input").attr('r','0');
		set_view();
	};
//	wskt.onerror=function() {
//		offline=true;
//		$('#clock').html("无法连接服务器").addClass('w');
//	};
}





