var zsd=new Array("zsd-e.jpg","zsd-n.jpg","zsd-ss2.gif");//变频器运行指示灯:停止,运行,告警
for(var i=zsd.length-1; i>=0; i--){//预加载指示灯图片
	var img='img/'+zsd[i];
	zsd[i]=new Image(20,20);
	zsd[i].src=img;
}


/**
 * 初始化创建表格 - 实时运行数据
 */
function init_tb(){
	var thc='流量,频率1,频率2,瓦特1A,瓦特1B,瓦特1C,瓦特1D,瓦特2A,瓦特2B,瓦特2C,瓦特2D,压力1,压力2,压力3,温度1,温度2,温度3,阀开度'.split(',');
	
	var tb=$('#frd'),tr;
	tb.append($('<caption/>').append('<h2>直连混热机组-监控</h2>&nbsp;&nbsp;<time/>'));	//添加标题
	
	{//添加表头行
		tb.append(tr=$('<tr><th/>').attr('id','rh'));
		for(var c=1; c<=7; c++){
			tr.append($('<th>分机#'+c+'<img/>').addClass('c'+c))
		}
		tr.find("img").each(function(i) {//指示灯初始为停止状态
			$(this).attr("src",zsd[0].src).dblclick(function(){
				if(zsd[0].src==$(this).attr("src")){
					alert('要启动【'+$(this).parent().text()+'】的变频器么？');
					$(this).attr("src",zsd[1].src);
				}else{
					alert('要停止【'+$(this).parent().text()+'】的变频器么？');
					$(this).attr("src",zsd[0].src);
				}
			});
		});
	}

	{//设定频率 - 行
		tb.append(tr=$('<tr><th>设定频率</th>').attr('id','rs1'));
		for(var c=1; c<=7; c++){
			tr.append($('<td><input s="0.1" d="50" x="0"/>').addClass('c'+c))
		}
		tr.find("input").each(function(i) {//设定频率值，双击可修改
			$(this).dblclick(function() {
				$(this).spinner({
					step : $(this).attr("s"),
					max:$(this).attr("d"),
					min:$(this).attr("x"),
					numberFormat : "n"
				});
				$(this).blur(function() {
					$(this).spinner("destroy");
				});
			});
			$(this).val(21+i);//模拟初始设定频率
		});
	}

	for(var r=0;r<thc.length;r++){//添加数据行
		tb.append(tr=$('<tr><th>'+thc[r]+'</th>').attr('id','rd'+r));
		for(var c=1; c<=7; c++){
			tr.append($('<td/>').addClass('c'+c).text(thc[r]+':'+c+r))
		}
	}
	
	init_th()
}


